﻿AffDots = LibStub( "AceAddon-3.0" ):NewAddon("AffDots","AceEvent-3.0")
local SharedMedia = LibStub("LibSharedMedia-3.0")

local me,spec				= 0, 0
local timer, throttle		= 0, 0.05
local dot_damage, targets	= {},{}
local track					= {}
local in_combat				= false
local colors
local setburst				= false
local _,player_resource_id, primary_resource_treshold, execute_percent
local spells = {
	corr	= GetSpellInfo(172),
	agony	= GetSpellInfo(980),
	ua		= GetSpellInfo(30108),
	coe		= GetSpellInfo(1490),
	poison	= GetSpellInfo(93068),
	shadowflame	= GetSpellInfo(47960),
}

local o

local defaults = {
	version_num	= 12004,
	locked		= false,
	affliction	= true,
	demonology	= true,
	destruction = true,
	hide 		= false,
	layout 		= "horizontal",
	reltext 	= true,
	hide_text	= false,
	hide_icons	= false,
	focus 		= false,
	coe 		= false,
	hp 			= false,
	color1		= {0,0.5,0},		--better, full pandemic benefit
	color2 		= {0.5,0.5,0},		--same, full pandemic benefit
	color3 		= {0.5,0.5,0},		--worse, full pandemic benefit
	color4 		= {0.2,0.2,1},		--better
	color5 		= {0.5,0,0},		--same
	color6		= {0.5,0,0},		--worse
	color7		= {0,0,0},			--no dot on target
	color8		= {0.2,0.2,0.2},	--bar background
	color9		= {0,0.5,0},		--coe/hp/haunt
	color10		= {0.5,0.5,0.5},	--tick/pandemic indicator
	text_color	= {1,0.8,0},
	scale 		= 1,
	focus_scale = 0.8,
	color_switch= 1.2,
	transparency= 0.5,
	font		= "Fonts\\FRIZQT__.TTF",
	bg			= "Interface\\TARGETINGFRAME\\UI-StatusBar",
	large_text_size = 14,
	small_text_size = 10,
	color_text		= false,
	aff			= {
		show_haunt		= true,
		agony			= 0,
		corr			= 1,
		ua				= 2,
		haunt			= 3,
	},
	demo		= {
		color1		= {0,0,0},
		color2		= {0.5,0.5,0},
		color3		= {0.5,0.5,0},
		color4		= {0,0,0.5},
		color5		= {0,0.5,0},
		switch1		= 200,
		switch2		= 400,
		switch3		= 600,
		switch4		= 800,
		switch5		= 1000,
		show_df			= true,
		show_hog		= true,
		corr			= 0,
		doom			= 1,
		hog				= 2,
		df				= 3,
	},
	destro		= {
		immo		= 0,
		conflag		= 1,
		rof			= 2,
		embers		= 3,
		show_embers	= true,
		show_conflag= true,
		show_rof	= true,
		color1		= {0,0,0},
		color2		= {0.5,0.5,0},
		color3		= {0,0,0.5},
		color4		= {0,0.5,0},
		switch1		= 10,
		switch2		= 20,
		switch3		= 30,
		switch4		= 40,
	},
	boxes_v		= {
		icon_size		= 30,
		icon_position	=  5,
		text_position	= 45,
		h				= 40,
		w				= 80,
	},
	boxes_h		= {
		icon_size		= 30,
		icon_position	= 35,
		text_position	= 12,
		h				= 70,
		w				= 40,
	},
	bars		= {
		h				= 20,
		w				= 200,
		margin			= 1,
		pandemic		= 1,
		text_position	= 0,
		proportional	= false,
		limit			= 24,
	},
	tidyplates	= {
		enable			= false,
		w				= 20,
		h				= 20,
		transparency	= 0.8,
	},
	burst		= {
		enable			= false,
		default			= {100, 100, 100},
		switch			= 1.25,
		color			= {0,1,0},
		text			= true,
		h				= 20,
		w				= 80,
		key				= "LALT",
		mousekey		= "RightButton",
	}
}
if not o then o = defaults end

local GetTime 				= GetTime
local GetMastery 			= GetMastery
local GetRangedHaste 		= GetRangedHaste
local GetSpellCritChance	= GetSpellCritChance
local GetSpellBonusDamage 	= GetSpellBonusDamage
local UnitDebuff 			= UnitDebuff
local UnitHealth 			= UnitHealth
local UnitHealthMax 		= UnitHealthMax
local UnitExists			= UnitExists
local UnitGUID				= UnitGUID
local math_floor			= math.floor

local m		= CreateFrame("Frame", "AffDotsTarget", UIParent)
local f		= CreateFrame("Frame", "AffDotsFocus", UIParent)
local b		= CreateFrame("Frame", "AffDotsBurst", UIParent)
b.bg	= b:CreateTexture()
b.text	= b:CreateFontString()
m:SetClampedToScreen(true)
f:SetClampedToScreen(true)
b:SetClampedToScreen(true)

local function OnMouseDown(self, button)
	if button == "LeftButton" and not self.isMoving and not setburst then
		self:StartMoving()
		self.isMoving = true
	elseif self == b and button == "RightButton" and setburst then
		AffDots:BurstDefaults()
	end
end

local function OnMouseUp(self, button)
	local p,_,rp, x, y = self:GetPoint()
	if		self == m then
		o.p = p; o.rp = rp; o.x = x; o.y = y
	elseif	self == f then
		o.focus_p = p; o.focus_rp = rp;	o.focus_x = x; o.focus_y = y
	elseif	self == b then
		o.burst.p = p; o.burst.rp = rp; o.burst.x = x; o.burst.y = y
	end
	if button == "LeftButton" and self.isMoving then
		self:StopMovingOrSizing()
		self:SetUserPlaced(false)
		self.isMoving = false
	end
end

m:SetScript("OnMouseDown", OnMouseDown)
f:SetScript("OnMouseDown", OnMouseDown)
b:SetScript("OnMouseDown", OnMouseDown)
m:SetScript("OnMouseUp", OnMouseUp)
f:SetScript("OnMouseUp", OnMouseUp)
b:SetScript("OnMouseUp", OnMouseUp)

local function Round(num) return math_floor(num+.5) end
local function SecondsRound(num)
	if num > 2 then return math_floor(num+.5)
	else return math_floor(num*10+.5)/10 end
end
local function tablecopy(orig)
    local orig_type = type(orig)
    local copy
    if orig_type == 'table' then
        copy = {}
        for orig_key, orig_value in next, orig, nil do
            copy[tablecopy(orig_key)] = tablecopy(orig_value)
        end
    else
        copy = orig
    end
    return copy
end

local function CombatLog(_,_,event_type,_,source_GUID,_,_,_,dest_GUID,_,_,_, ...)
	if(source_GUID ~= me or (event_type ~= "SPELL_AURA_REFRESH" and event_type ~= "SPELL_AURA_APPLIED" and event_type ~= "SPELL_DAMAGE")) then
		return
	end
	spell = select(1, ...)
	if spec == 1 then
		if(event_type == "SPELL_AURA_APPLIED" or event_type == "SPELL_AURA_REFRESH") then
			if(spell == 30108) then
				targets[dest_GUID.."30108"] = {dot_damage[30108][1],GetTime(),dot_damage[30108][2]}
			elseif(spell == 172 or spell == 87389) then
				targets[dest_GUID.."172"] = {dot_damage[172][1],GetTime(),dot_damage[172][2]}
			elseif(spell == 980) then
				targets[dest_GUID.."980"] = {dot_damage[980][1],GetTime(),dot_damage[980][2],0}
			end
		elseif(event_type == "SPELL_DAMAGE" and spell == 77799) then
			targets[dest_GUID.."172"] = {dot_damage[172][1],GetTime(),dot_damage[172][2]}
			targets[dest_GUID.."30108"] = {dot_damage[30108][1],GetTime(),dot_damage[30108][2]}
		end
	elseif spec == 2 then
		if(event_type == "SPELL_AURA_APPLIED" or event_type == "SPELL_AURA_REFRESH") then
			if(spell == 172) then
				targets[dest_GUID.."172"] = {dot_damage[172][1],GetTime(),dot_damage[172][2]}
			elseif(spell == 603) then
				targets[dest_GUID.."603"] = {dot_damage[603][1],GetTime(),dot_damage[603][2]}
			end
		elseif(event_type == "SPELL_DAMAGE" and (spell == 103964 or spell == 77799 or spell == 115422)) then
			targets[dest_GUID.."172"] = {dot_damage[172][1],GetTime(),dot_damage[172][2]}
		end
	elseif spec == 3 then
		if(event_type == "SPELL_AURA_APPLIED" or event_type == "SPELL_AURA_REFRESH") then
			if(spell == 348) then
				targets[dest_GUID.."348"] = {dot_damage[348][1],GetTime(),dot_damage[348][2]}
				targets[dest_GUID.."108686"] = nil
			elseif(spell == 108686) then
				targets[dest_GUID.."108686"] = {dot_damage[108686][1],GetTime(),dot_damage[108686][2]}
				targets[dest_GUID.."348"] = nil
			end
		end
	end
end

local function GetDotDmg()
	local mastery, haste, crit, spd = GetMastery(), GetRangedHaste(), GetSpellCritChance(6), GetSpellBonusDamage(6)

	local damage_bonus, tick_every, ticks, duration, damage, dps, bonus
	if spec==1 then --Affliction
		damage_bonus 		= (1+crit/100)*(1+(mastery*3.1)/100)
		tick_every 			= 2/(1+(haste/100))

		ticks 				= Round(24/tick_every)
		duration 			= ticks * tick_every
		damage				= ticks*(280+spd*0.26)*damage_bonus
		dps					= Round(damage/duration)
		dot_damage[980]		= {Round(dps/100)/10, tick_every}

		ticks 				= Round(18/tick_every)
		duration 			= ticks * tick_every
		damage		 		= (1926+ticks*spd*0.2)*damage_bonus
		dps					= Round(damage/duration)
		dot_damage[172]		= {Round(dps/100)/10, tick_every}

		ticks 				= Round(14/tick_every)
		duration 			= ticks * tick_every
		damage 				= (1792+ticks*spd*0.24)*damage_bonus
		dps		 			= Round(damage/duration)
		dot_damage[30108]	= {Round(dps/100)/10, tick_every}
	elseif spec==2 then --Demonology
		damage_bonus 		= (1+crit/100)*(1+(mastery)/100)
		bonus				= (1+crit/100)*(1+(mastery*3)/100)

		tick_every 			= 2/(1+(haste/100))
		ticks 				= Round(18/tick_every)
		duration 			= ticks * tick_every
		damage		 		= (1926+ticks*spd*0.2)*damage_bonus
		dps					= Round(damage/duration)
		dot_damage[172]		= {Round(dps/100)/10, tick_every}

		tick_every 			= 15/(1+(haste/100))
		ticks 				= Round(60/tick_every)
		duration 			= ticks * tick_every
		damage		 		= (1068+spd)*bonus*ticks
		dps					= Round(damage/duration)
		dot_damage[603]		= {Round(dps/100)/10, tick_every}
	elseif spec==3 then --Destruction
		damage_bonus 		= (1+crit/100)*(1+(mastery+1)/100)
		bonus				= (100+mastery*3)*0.35/100

		tick_every 			= 3/(1+(haste/100))
		ticks 				= Round(15/tick_every)
		duration 			= ticks * tick_every
		damage		 		= (1980+ticks*spd*0.371)*damage_bonus
		dps					= Round(damage/duration)
		dot_damage[348]		= {Round(dps/100)/10, tick_every}
		dot_damage[108686]	= {Round(dps*bonus/100)/10, tick_every}
	end
end

function AffDots:BurstDefaults()
	if spec == 1 then
		o.burst.default[1] = dot_damage[172][1] + dot_damage[980][1] + dot_damage[30108][1]
	elseif spec == 2 then
		o.burst.default[2] = dot_damage[172][1]
	elseif spec == 3 then
		o.burst.default[3] = dot_damage[348][1]
	end
end

local function FindColor(GUID,time_left,spell,pandemic)
	if not targets[GUID..spell] or not dot_damage[spell] then
		return 7
	end
	local color = 5
	local current 		= dot_damage[spell][1]
	local on_target 	= targets[GUID..spell][1]
	if		(on_target  < current and time_left <= pandemic) then color = 1
	elseif 	(on_target == current and time_left <= pandemic) then color = 2
	elseif	(on_target  > current and time_left <= pandemic) then color = 3
	elseif	(on_target*o.color_switch < current and time_left  > pandemic) then color = 4
	elseif	(on_target  > current and time_left  > pandemic) then color = 6
	end
	return color
end

local Update = {
	bar_dot	= function(f)
		local color = 7
		local guid = UnitGUID(f.target)
		local _,_,_,_,_,duration,expires = UnitDebuff(f.target,f.name,f.rank,"player")
		if duration and guid and targets[guid..f.spell] then
			local duration_left = expires - GetTime()
			color = FindColor(guid,duration_left,f.spell,f.pandemic)
			if f.spell == 980 then
				if targets[guid..f.spell][4] == 0 then
					targets[guid.."980"][4] = expires
				elseif expires - targets[guid..f.spell][4] > 1 then
					targets[guid.."980"][1] = dot_damage[980][1]
					targets[guid.."980"][3] = dot_damage[980][2]
				end
			end
			f.statusbar:SetStatusBarColor(colors[color][1],colors[color][2],colors[color][3],1)
			f.statusbar:SetValue(duration_left)
			if o.bars.proportional then
				f.tick:SetPoint("LEFT",o.bars.w*targets[guid..f.spell][3]/o.bars.limit,0)
			else
				f.tick:SetPoint("LEFT",o.bars.w*targets[guid..f.spell][3]/f.duration,0)
			end
			f.tick:Show()
			if o.color_text then f.t1:SetTextColor(colors[color][1],colors[color][2],colors[color][3]) end
			if o.reltext then f.t1:SetText(Round(dot_damage[f.spell][1]*100/targets[guid..f.spell][1]))
			else f.t1:SetText(dot_damage[f.spell][1].."/"..targets[guid..f.spell][1]) end
			if(expires-f.timer>1) then
				f.timer = expires
			end
			f.t2:SetText(SecondsRound(f.timer-GetTime()))
		else
			f.statusbar:SetStatusBarColor(colors[7][1],colors[7][2],colors[7][3],1)
			f.statusbar:SetValue(0)
			f.tick:Hide()
			f.t1:SetText(0)
			f.t2:SetText("")
			f.timer = 0
			if o.color_text then f.t1:SetTextColor(o.text_color[1],o.text_color[2],o.text_color[3]) end
		end
	end,
	box_dot = function(f)
		local color = 7
		local guid = UnitGUID(f.target)
		local _,_,_,_,_,duration,expires = UnitDebuff(f.target,f.name,f.rank,"player")
		if duration and guid and targets[guid..f.spell] then
			local current 		= dot_damage[f.spell][1]
			if not targets[guid..f.spell] then return false end
			local on_target 	= targets[guid..f.spell][1]
			local duration_left = expires - GetTime()
			color = FindColor(guid,duration_left,f.spell,f.pandemic)
			if f.spell == 980 then
				if targets[guid..f.spell][4] == 0 then
					targets[guid.."980"][4] = expires
				elseif expires - targets[guid..f.spell][4] > 1 then
					targets[guid.."980"][1] = dot_damage[980][1]
					targets[guid.."980"][3] = dot_damage[980][2]
				end
			end
			if o.color_text then f.t1:SetTextColor(colors[color][1],colors[color][2],colors[color][3]) end
			if not o.hide_icons then f.cd:SetCooldown(expires-duration, duration) end
			if o.reltext then f.t1:SetText(Round(current*100/on_target))
			else f.t1:SetText(current.."|n"..on_target) end
		else
			if o.color_text then f.t1:SetTextColor(o.text_color[1],o.text_color[2],o.text_color[3]) end
			f.cd:Hide()
			f.t1:SetText(0)
		end
		f.bg:SetTexture(colors[color][1],colors[color][2],colors[color][3],o.transparency)
	end,
	bar_haunt = function(f)
		local color = 7
		local bg_color = 8
		local _,_,_,_,_,duration,expires = UnitDebuff(f.target, f.name,"","player")
		if(UnitPower("player", player_resource_id) >= primary_resource_treshold) then
			bg_color = 9
		end
		f.t1:SetText(UnitPower("player", player_resource_id))
		if(expires) then
			color = 9
			bg_color = 8
			f.statusbar:SetValue((expires - GetTime()))
			if(expires-f.timer>1) then
				f.timer = expires
			end
			f.t2:SetText(SecondsRound(f.timer-GetTime()))
		else
			f.statusbar:SetValue(0)
			f.t2:SetText("")
			f.timer = 0
		end
		f.bg:SetVertexColor(colors[bg_color][1],colors[bg_color][2],colors[bg_color][3],1)
		f.statusbar:SetStatusBarColor(colors[color][1],colors[color][2],colors[color][3],1)
	end,
	box_haunt = function(f)
		local color = 7
		local _,_,_,_,_,duration,expires = UnitDebuff(f.target, f.name,"","player")
		if(UnitPower("player", player_resource_id) >= primary_resource_treshold) then
			color = 9
		end
		f.t1:SetText(UnitPower("player", player_resource_id))
		if(expires) then
			if not o.hide_icons then f.cd:SetCooldown(expires-duration, duration);f.cd:Show(); end
		else
			f.cd:Hide();
		end
		f.bg:SetTexture(colors[color][1],colors[color][2],colors[color][3],o.transparency)
	end,
	coe = function(f)
		local _,_,_,_,_,_,expires1 = UnitDebuff(f.target, spells.coe)
		local _,_,_,_,_,_,expires2 = UnitDebuff(f.target, spells.poison)
		local expires = expires1 or expires2
		if expires then
			local time_remaining = expires - GetTime()
			if 		time_remaining>60 	then f.t1:SetText((math_floor(time_remaining/60)+1).."m")
			elseif 	time_remaining>10	then f.t1:SetText("0:" ..math_floor(time_remaining))
			else 							 f.t1:SetText("0:0"..math_floor(time_remaining))
			end
			f.bg:SetTexture(colors[9][1],colors[9][2],colors[9][3],o.transparency)
		else
			f.t1:SetText("")
			f.bg:SetTexture(colors[7][1],colors[7][2],colors[7][3],o.transparency)
		end
	end,
	hp = function(f)
		local color = 7
		if UnitExists(f.target) then
			local hp = Round(UnitHealth(f.target)*100/UnitHealthMax(f.target))
			f.t1:SetText(hp)
			if execute_percent >= hp then
				color = 9
			end
		end
		f.bg:SetTexture(colors[color][1],colors[color][2],colors[color][3],o.transparency)
	end,
	burst = function(f)
		local current = 0
		local target = UnitGUID("target")
			
		if spec == 1 and target then
			local _,_,_,_,_,_,expires1 = UnitDebuff("target", spells.corr,nil,"player")
			local _,_,_,_,_,_,expires2 = UnitDebuff("target", spells.agony,nil,"player")
			local _,_,_,_,_,_,expires3 = UnitDebuff("target", spells.ua,nil,"player")
			if expires1 and targets[target.."172"] then current = current + targets[target.."172"][1] end
			if expires2 and targets[target.."980"] then current = current + targets[target.."980"][1] end
			if expires3 and targets[target.."30108"] then current = current + targets[target.."30108"][1] end
		elseif spec == 2 then
			current = dot_damage[172][1]
		elseif spec == 3 then
			current = dot_damage[348][1]
		end
		local damage = current/o.burst.default[spec]
		if damage > o.burst.switch then
			b.bg:SetTexture(o.burst.color[1],o.burst.color[2],o.burst.color[3],o.transparency);
		else
			b.bg:SetTexture(colors[7][1],colors[7][2],colors[7][3],o.transparency);
		end
		b.text:SetText(Round(damage*100))
	end,
	box_hog = function(f)
		local currentCharges, maxCharges, timeLastCast, cooldownDuration = GetSpellCharges(105174)
		local color =7
		if currentCharges == maxCharges then
			f.t1:SetText(currentCharges)
			color = 9
		else
			local t = cooldownDuration-GetTime()+timeLastCast
			f.t1:SetText(currentCharges.."/"..SecondsRound(t))
			if currentCharges == maxCharges - 1 and t < 5 then
				color = 9
			end
		end
		local _,_,_,_,_,duration,expires = UnitDebuff("target", spells.shadowflame,nil,"player")
		if expires then
			f.t2:SetText(expires-GetTime())
			if not o.hide_icons then f.cd:SetCooldown(expires-duration, duration) end
		else
			f.t2:SetText("")
			f.cd:Hide()
		end
		f.bg:SetTexture(colors[color][1],colors[color][2],colors[color][3],o.transparency)
	end,
	box_df = function(f)
		local power = UnitPower("player", player_resource_id)
		local color = 1
		if 		power <= o.demo.switch1 then color = 1
		elseif 	power <= o.demo.switch2 then color = 2
		elseif 	power <= o.demo.switch3 then color = 3
		elseif 	power <= o.demo.switch4 then color = 4
		elseif 	power <= o.demo.switch5 then color = 5
		end
		f.t1:SetText(power)
		f.bg:SetTexture(o.demo["color"..color][1],o.demo["color"..color][2],o.demo["color"..color][3],o.transparency)
	end,
	bar_hog = function(f)
		local currentCharges, maxCharges, timeLastCast, cooldownDuration = GetSpellCharges(105174)
		local color = 8
		if currentCharges == maxCharges then
			f.t1:SetText(currentCharges)
			color = 9
		else
			local t = cooldownDuration-GetTime()+timeLastCast
			f.t1:SetText(currentCharges.."/"..SecondsRound(t))
			if currentCharges == maxCharges - 1 and t < 5 then
				color = 9
			end
		end
		local _,_,_,_,_,_,expires = UnitDebuff("target", spells.shadowflame,nil,"player")
		if expires then
			f.t2:SetText(SecondsRound(expires-GetTime()))
			f.statusbar:SetValue(expires-GetTime())
		else
			f.t2:SetText("")
			f.statusbar:SetValue(0)
		end
		f.bg:SetVertexColor(colors[color][1],colors[color][2],colors[color][3],1)
		f.statusbar:SetStatusBarColor(colors[9][1],colors[9][2],colors[9][3],1)
	end,
	bar_df = function(f)
		local power = UnitPower("player", player_resource_id)
		local color = 1
		if 		power <= o.demo.switch1 then color = 1
		elseif 	power <= o.demo.switch2 then color = 2
		elseif 	power <= o.demo.switch3 then color = 3
		elseif 	power <= o.demo.switch4 then color = 4
		elseif 	power <= o.demo.switch5 then color = 5
		end
		f.t1:SetText(power)
		f.statusbar:SetValue(power)
		f.statusbar:SetStatusBarColor(o.demo["color"..color][1],o.demo["color"..color][2],o.demo["color"..color][3],1)
	end,
	box_immo = function(f)
		local color = 7
		local guid = UnitGUID(f.target)
		local _,_,_,_,_,duration,expires,_,_,_,id = UnitDebuff(f.target,f.name,f.rank,"player")
		if duration and guid and targets[guid..id] then
			if id == 348 and f.iconfile == "Interface\\Icons\\Ability_Mage_WorldInFlames" then
				f.iconfile = "Interface\\Icons\\Spell_Fire_Immolation"
				f.icon.file:SetTexture(f.iconfile)
			elseif id == 108686 and f.iconfile == "Interface\\Icons\\Spell_Fire_Immolation" then
				f.iconfile = "Interface\\Icons\\Ability_Mage_WorldInFlames"
				f.icon.file:SetTexture(f.iconfile)
			end
			local current 		= dot_damage[id][1]
			if not targets[UnitGUID(f.target)..id] then return false end
			local on_target 	= targets[UnitGUID(f.target)..id][1]
			local duration_left = expires - GetTime()
			color = FindColor(guid,duration_left,id,f.pandemic)
			if o.color_text then f.t1:SetTextColor(colors[color][1],colors[color][2],colors[color][3]) end
			if not o.hide_icons then f.cd:SetCooldown(expires-duration, duration) end
			if o.reltext then f.t1:SetText(Round(current*100/on_target))
			else f.t1:SetText(current.."|n"..on_target) end
		else
			if f.iconfile ~= "Interface\\Icons\\Spell_Fire_Immolation" then
				f.iconfile = "Interface\\Icons\\Spell_Fire_Immolation"
				f.icon.file:SetTexture(f.iconfile)
			end
			if o.color_text then f.t1:SetTextColor(o.text_color[1],o.text_color[2],o.text_color[3]) end
			f.cd:Hide()
			f.t1:SetText(0)
		end
		f.bg:SetTexture(colors[color][1],colors[color][2],colors[color][3],o.transparency)
	end,
	bar_immo	= function(f)
		local color = 7
		local guid = UnitGUID(f.target)
		local _,_,_,_,_,duration,expires,_,_,_,id = UnitDebuff(f.target,f.name,f.rank,"player")
		if duration and guid and targets[guid..id] then
			if id == 348 and f.iconfile == "Interface\\Icons\\Ability_Mage_WorldInFlames" then
				f.iconfile = "Interface\\Icons\\Spell_Fire_Immolation"
				f.icon.file:SetTexture(f.iconfile)
			elseif id == 108686 and f.iconfile == "Interface\\Icons\\Spell_Fire_Immolation" then
				f.iconfile = "Interface\\Icons\\Ability_Mage_WorldInFlames"
				f.icon.file:SetTexture(f.iconfile)
			end
			local duration_left = expires - GetTime()
			color = FindColor(guid,duration_left,id,f.pandemic)
			f.statusbar:SetStatusBarColor(colors[color][1],colors[color][2],colors[color][3],1)
			f.statusbar:SetValue(duration_left)
			if o.bars.proportional then
				f.tick:SetPoint("LEFT",o.bars.w*targets[guid..id][3]/o.bars.limit,0)
			else
				f.tick:SetPoint("LEFT",o.bars.w*targets[guid..id][3]/f.duration,0)
			end
			f.tick:Show()
			if o.color_text then f.t1:SetTextColor(colors[color][1],colors[color][2],colors[color][3]) end
			if o.reltext then f.t1:SetText(Round(dot_damage[id][1]*100/targets[guid..id][1]))
			else f.t1:SetText(dot_damage[id][1].."/"..targets[guid..id][1]) end
			if(expires-f.timer>1) then
				f.timer = expires
			end
			f.t2:SetText(SecondsRound(f.timer-GetTime()))
		else
			if f.iconfile ~= "Interface\\Icons\\Spell_Fire_Immolation" then
				f.iconfile = "Interface\\Icons\\Spell_Fire_Immolation"
				f.icon.file:SetTexture(f.iconfile)
			end
			f.statusbar:SetStatusBarColor(colors[7][1],colors[7][2],colors[7][3],1)
			f.statusbar:SetValue(0)
			f.tick:Hide()
			f.t1:SetText(0)
			f.t2:SetText("")
			f.timer = 0
			if o.color_text then f.t1:SetTextColor(o.text_color[1],o.text_color[2],o.text_color[3]) end
		end
	end,
	box_embers = function(f)
		local power = UnitPower("player", player_resource_id, true)
		local color
		if 		power <= o.destro.switch1 then color = 1
		elseif 	power <= o.destro.switch2 then color = 2
		elseif 	power <= o.destro.switch3 then color = 3
		elseif 	power <= o.destro.switch4 then color = 4
		end
		f.t1:SetText(power)
		f.bg:SetTexture(o.destro["color"..color][1],o.destro["color"..color][2],o.destro["color"..color][3],o.transparency)
	end,
	bar_embers = function(f)
		local power = UnitPower("player", player_resource_id, true)
		local color
		if 		power <= o.destro.switch1 then color = 1
		elseif 	power <= o.destro.switch2 then color = 2
		elseif 	power <= o.destro.switch3 then color = 3
		elseif 	power <= o.destro.switch4 then color = 4
		end
		f.t1:SetText(power)
		f.statusbar:SetValue(power)
		f.statusbar:SetStatusBarColor(o.destro["color"..color][1],o.destro["color"..color][2],o.destro["color"..color][3],1)
	end,
	box_conflag = function(f)
		local currentCharges, maxCharges, timeLastCast, cooldownDuration = GetSpellCharges(17962)
		local color =7
		if currentCharges == maxCharges then
			color = 9
			f.cd:Hide()
		else
			if not o.hide_icons then f.cd:SetCooldown(timeLastCast, cooldownDuration) end
		end
		f.t1:SetText(currentCharges)
		f.bg:SetTexture(colors[color][1],colors[color][2],colors[color][3],o.transparency)
	end,
	bar_conflag = function(f)
		local currentCharges, maxCharges, timeLastCast, cooldownDuration = GetSpellCharges(17962)
		local color = 8
		if currentCharges == maxCharges then
			color = 9
			f.t2:SetText("")
		else
			local t = cooldownDuration-GetTime()+timeLastCast
			f.t2:SetText(SecondsRound(t))
		end
		f.t1:SetText(currentCharges)
		f.statusbar:SetValue(currentCharges)
		f.bg:SetVertexColor(colors[color][1],colors[color][2],colors[color][3],1)
		f.statusbar:SetStatusBarColor(colors[9][1],colors[9][2],colors[9][3],1)
	end,
	rof = function(f)
		local _,_,_,_,_,duration,expires = UnitAura("player",f.name,nil,"player")
		if o.layout == "bars" then
			f.statusbar:SetStatusBarColor(colors[9][1],colors[9][2],colors[9][3],1)
			if expires then
				--local t = SecondsRound(expires-GetTime())
				f.statusbar:SetValue(expires-GetTime())
				f.t2:SetText(SecondsRound(expires-GetTime()))
			else
				f.statusbar:SetValue(0)
				f.t2:SetText("")
			end
		else
			if expires then
				if not o.hide_icons then f.cd:SetCooldown(expires-duration, duration) end
				f.bg:SetTexture(colors[9][1],colors[9][2],colors[9][3],o.transparency)
			else
				f.cd:Hide()
				f.bg:SetTexture(colors[7][1],colors[7][2],colors[7][3],o.transparency)
			end
		end
	end,
}

local function Visibility()
	if(o.hide and not in_combat) then
		m:Hide(); if o.burst.enable then b:Hide() end
	else
		m:Show(); if o.burst.enable then b:Show() end
	end

	if(UnitGUID("focus") and o.focus and (in_combat or not o.hide)) then
		f:Show()
	else
		f:Hide()
	end

	m:SetMovable(not o.locked);m:EnableMouse(not o.locked)
	f:SetMovable(not o.locked);f:EnableMouse(not o.locked)
	b:SetMovable(not o.locked);b:EnableMouse(not o.locked)
end

---------------------------------------------------------------
local framepool, active_frames = {}, {}
function AffDots:ReleaseFrames()
	for i,f in pairs(active_frames) do
		f:Hide()
		tinsert(framepool, f)
	end
	wipe(active_frames)
end
function AffDots:GetFrame(parent)
	local f = tremove(framepool)
	if not f then
		f			= CreateFrame("Frame", nil, parent)
		f.statusbar	= CreateFrame("StatusBar", nil, f)
		f.bg		= f.statusbar:CreateTexture(nil, "BACKGROUND")
		f.tick1		= f.statusbar:CreateTexture(nil, "OVERLAY")
		f.tick2		= f.statusbar:CreateTexture(nil, "OVERLAY")
		f.t1		= f.statusbar:CreateFontString(nil, "OVERLAY")
		f.t2		= f.statusbar:CreateFontString(nil, "OVERLAY")
		f.icon		= CreateFrame("Frame", nil, f.statusbar)
		f.icon.file	= f.icon:CreateTexture(nil, "OVERLAY")
		f.cd		= CreateFrame("COOLDOWN", nil, f.icon)
		f.statusbar:SetAllPoints(f)
		f.bg:SetAllPoints(f.statusbar)
		f.cd:SetAllPoints(f.icon)
		f.icon.file:SetAllPoints(f.icon)
		f.t1:SetFont("Fonts\\FRIZQT__.TTF",14,"OUTLINE")
		f.t2:SetFont("Fonts\\FRIZQT__.TTF",14,"OUTLINE")
	else
		f:SetParent(parent)
	end
	tinsert(active_frames, f)
	f:Show()
	return f
end
---------------------------------------------------------------

local function AffDotsTrack(id,type,target,duration,order,active)
	if not active then return end
	local spell = {}
	local parent
	if target == "target" then parent = m else parent = f end
	frame = AffDots:GetFrame(parent)
	if target == "target" then frame:SetScale(o.scale) else frame:SetScale(o.focus_scale) end
	if(type ~= "coe" and type ~= "hp") then
		local n,r,i = GetSpellInfo(id)
		spell["duration" ]	= duration*1.5
		spell["pandemic" ]	= duration/2
		spell["name"	 ]	= n
		spell["rank"	 ]	= r
		spell["iconfile" ]	= i
		spell["spell"	 ]	= id
		spell["timer"	 ]	= 0
	end
	spell["frame"	 ] 	= frame
	spell["t"		 ]	= type
	spell["target"	 ]	= target
	spell["order"	 ]	= order
	spell["icon"	 ]	= frame.icon
	spell["statusbar"]	= frame.statusbar
	spell["pandemict"]	= frame.tick2
	spell["tick"	 ]	= frame.tick1
	spell["cd"		 ]	= frame.cd
	spell["bg"		 ]	= frame.bg
	spell["t1"		 ]	= frame.t1
	spell["t2"		 ]	= frame.t2
	if		type == "coe"	then spell["update"] = Update.coe
	elseif	type == "hp"	then spell["update"] = Update.hp
	elseif	type == "dot"	then
		if o.layout == "bars" then spell["update"] = Update.bar_dot
		else spell["update"] = Update.box_dot end
	elseif type == "debuff" then
		if id == 48181 then
			spell["duration" ]	= 8
			if o.layout == "bars" then spell["update"] = Update.bar_haunt
			else spell["update"] = Update.box_haunt end
		elseif id == 105174 then
			spell["duration" ]	= 6
			if o.layout == "bars" then spell["update"] = Update.bar_hog
			else spell["update"] = Update.box_hog end
		elseif id == 104315 then
			spell["noprop"]	= true
			spell["duration" ]	= 1000
			if o.layout == "bars" then spell["update"] = Update.bar_df
			else spell["update"] = Update.box_df end
		elseif id == 108647 then
			spell["noprop"]	= true
			spell["duration" ]	= 40
			if o.layout == "bars" then spell["update"] = Update.bar_embers
			else spell["update"] = Update.box_embers end
		elseif id == 17962 then
			spell["duration" ]	= 2
			if o.layout == "bars" then spell["update"] = Update.bar_conflag
			else spell["update"] = Update.box_conflag end
		elseif id == 5740 then
			spell["duration" ]	= 7
			spell["update"] = Update.rof
		end
	end
	if id == 348 then
		if o.layout == "bars" then spell["update"] = Update.bar_immo
		else spell["update"] = Update.box_immo end
	end
	tinsert(track, spell)
end

local function InitFrames()
	local font		= SharedMedia:Fetch("font", o.font)
	local statusbar = SharedMedia:Fetch("statusbar", o.bg)
	AffDots:ReleaseFrames()
	wipe(track)
	if spec ~= 1 and spec ~= 2 and spec ~= 3 then m:Hide(); f:Hide(); b:Hide(); return end
	m:ClearAllPoints();f:ClearAllPoints()
	m:Show(); if o.focus then f:Show() end
	local height
	if spec == 1 then
		height = 3
		if o.aff.haunt then height = 4 end
	elseif spec == 2 then
		height = 2
		if o.demo.hog then height = height + 1 end
		if o.demo.df  then height = height + 1 end
	elseif spec == 3 then
		height = 1
		if o.destro.conflag then height = height + 1 end
		if o.destro.embers  then height = height + 1 end
	end
	if(o.layout == "horizontal") then
		m:SetSize(height*o.boxes_h.w*o.scale, o.boxes_h.h*o.scale)
		f:SetSize(height*o.boxes_h.w*o.focus_scale, o.boxes_h.h*o.focus_scale)
	elseif(o.layout == "vertical") then
		m:SetSize(o.boxes_v.w*o.scale, height*o.boxes_v.h*o.scale)
		f:SetSize(o.boxes_v.w*o.focus_scale, height*o.boxes_v.h*o.focus_scale)
	elseif(o.layout == "bars") then
		m:SetSize(o.bars.w*o.scale, height*(o.bars.h+o.bars.margin)*o.scale)
		f:SetSize(o.bars.w*o.focus_scale, height*(o.bars.h+o.bars.margin)*o.focus_scale)
	end
	if(o.x and o.y and o.p and o.rp) then
		m:SetPoint(o.p, nil, o.rp, o.x, o.y)
	else
		m:SetPoint("CENTER", 0, 0)
	end
	if(o.focus_x and o.focus_y and o.focus_p and o.focus_rp) then
		f:SetPoint(o.focus_p, nil, o.focus_rp, o.focus_x, o.focus_y)
	else
		f:SetPoint("CENTER", 0, 100)
	end
	if spec == 1 then
		if not o.affliction then m:Hide(); f:Hide(); return end
		player_resource_id	= 7; primary_resource_treshold = 4; execute_percent = 20;
		AffDotsTrack(   172,	"dot","target",18,  o.aff.corr,				true)
		AffDotsTrack(   980,	"dot","target",24, o.aff.agony,				true)
		AffDotsTrack( 30108,	"dot","target",14,    o.aff.ua,				true)
		AffDotsTrack( 48181, "debuff","target", 0, o.aff.haunt,	o.aff.show_haunt)
		AffDotsTrack( 	  0,	 "hp","target", 0,			 0,				o.hp)
		AffDotsTrack( 	  0,	"coe","target", 0,			 1,			   o.coe)
		if o.focus then
		AffDotsTrack(   172,	"dot", "focus",18,  o.aff.corr,				true)
		AffDotsTrack(   980,	"dot", "focus",24, o.aff.agony,				true)
		AffDotsTrack( 30108,	"dot", "focus",14,    o.aff.ua,				true)
		AffDotsTrack( 	  0,	 "hp", "focus", 0,			 0,	  			o.hp)
		AffDotsTrack( 	  0,	"coe", "focus", 0,			 1,	 		   o.coe)
		end
	elseif spec == 2 then
		if not o.demonology then m:Hide(); f:Hide(); return end
		player_resource_id	= 15; primary_resource_treshold = 800; execute_percent = 25;
		AffDotsTrack(   172,	"dot","target",18, o.demo.corr,			   true)
		AffDotsTrack(   603,	"dot","target",60, o.demo.doom,			   true)
		AffDotsTrack(105174, "debuff","target", 0,  o.demo.hog, o.demo.show_hog)
		AffDotsTrack(104315, "debuff","target", 0,   o.demo.df,	 o.demo.show_df)
		AffDotsTrack( 	  0,	 "hp","target", 0,		     0,			   o.hp)
		AffDotsTrack( 	  0,	"coe","target", 0,		     1,			  o.coe)
		if o.focus then
		AffDotsTrack(   172,	"dot", "focus",18, o.demo.corr,			   true)
		AffDotsTrack(   603,	"dot", "focus",60, o.demo.doom,			   true)
		AffDotsTrack( 	  0,	 "hp", "focus", 0,			 0,			   o.hp)
		AffDotsTrack( 	  0,	"coe", "focus", 0,			 1,			  o.coe)
		end
	elseif spec == 3 then
		if not o.destruction then m:Hide(); f:Hide(); return end
		player_resource_id	= 14; primary_resource_treshold = 38; execute_percent = 20;
		AffDotsTrack(   348,	"dot","target",15,		o.destro.immo,				   true)
		AffDotsTrack( 17962, "debuff","target", 0,	 o.destro.conflag,o.destro.show_conflag)
		AffDotsTrack(108647, "debuff","target", 0,    o.destro.embers, o.destro.show_embers)
		AffDotsTrack(  5740, "debuff","target", 0,    	 o.destro.rof, 	  o.destro.show_rof)
		AffDotsTrack( 	  0,	 "hp","target", 0,		     		0,				   o.hp)
		AffDotsTrack( 	  0,	"coe","target", 0,		     		1,				  o.coe)
		if o.focus then
		AffDotsTrack(   348,	"dot", "focus",15,		o.destro.immo,				   true)
		AffDotsTrack( 	  0,	 "hp", "focus", 0,					0,				   o.hp)
		AffDotsTrack( 	  0,	"coe", "focus", 0,			 		1,				  o.coe)
		end
	end
	
	--layout
	for k,v in pairs(track) do
		local c = track[k]
		c.t1:SetTextColor(unpack(o.text_color))
		c.t2:SetTextColor(unpack(o.text_color))
		c.icon:Hide();c.cd:Hide();c.t1:Hide();c.t2:Hide();c.tick:Hide();c.pandemict:Hide();
		c.frame:ClearAllPoints();c.icon:ClearAllPoints();c.t1:ClearAllPoints();c.t2:ClearAllPoints();
		c.t1:SetText("");c.t2:SetText("")
		c.bg:SetTexture(statusbar)
		c.bg:SetVertexColor(1, 1, 1, 1)
		c.statusbar:SetValue(0)
		if c.t == "dot" or c.t == "debuff" then
			if o.layout == "horizontal" then
				c.frame:SetSize(o.boxes_h.w,o.boxes_h.h)
				c.frame:SetPoint("TOPLEFT", o.boxes_h.w*c.order, 0)
				c.icon.file:SetTexture(c.iconfile)
				c.icon:SetSize(o.boxes_h.icon_size,o.boxes_h.icon_size)
				c.icon.file:SetTexCoord(0.1,0.9,0.1,0.9)
				c.icon:SetPoint("TOP",0,-o.boxes_h.icon_position)
				c.t1:SetPoint("TOP",0,-o.boxes_h.text_position);c.t1:SetFont(font,o.large_text_size,"OUTLINE")
				if not o.hide_text then c.t1:Show() end
				if not o.hide_icons then c.icon:Show();c.cd:Show() end
			elseif o.layout == "vertical" then
				c.frame:SetSize(o.boxes_v.w,o.boxes_v.h)
				c.frame:SetPoint("TOPLEFT", 0, -o.boxes_v.h*c.order)
				c.icon.file:SetTexture(c.iconfile)
				c.icon:SetSize(o.boxes_v.icon_size,o.boxes_v.icon_size)
				c.icon.file:SetTexCoord(0.1,0.9,0.1,0.9)
				c.icon:SetPoint("LEFT",o.boxes_v.icon_position,0)
				c.t1:SetPoint("RIGHT",o.boxes_v.text_position-50,0);c.t1:SetFont(font,o.large_text_size,"OUTLINE")
				if not o.hide_text then c.t1:Show() end
				if not o.hide_icons then c.icon:Show();c.cd:Show() end
			elseif o.layout == "bars" then
				c.frame:SetSize(o.bars.w,o.bars.h)
				c.frame:SetPoint("TOPLEFT",0,-o.bars.h*c.order-(c.order*o.bars.margin))
				c.tick:SetPoint("LEFT",0,0)
				c.tick:SetSize(o.bars.pandemic,o.bars.h)
				c.tick:SetTexture("Interface\\CastingBar\\UI-CastingBar-Spark")
				c.tick:SetVertexColor(1, 1, 1, 0.75);
				c.statusbar:SetStatusBarTexture(statusbar)
				c.statusbar:GetStatusBarTexture():SetHorizTile(false)
				c.statusbar:GetStatusBarTexture():SetVertTile(false)
				c.statusbar:SetStatusBarColor(0, 0, 0, o.transparency)
				if o.bars.proportional and not c.noprop then
					if c.spell == 48181 then
						c.pandemict:SetPoint("LEFT",12/o.bars.limit*o.bars.w,0)
					else
						c.pandemict:SetPoint("LEFT",c.pandemic/o.bars.limit*o.bars.w,0)
					end
					c.statusbar:SetMinMaxValues(0, o.bars.limit)
				else
					c.pandemict:SetPoint("LEFT",1/3*o.bars.w,0)
					c.statusbar:SetMinMaxValues(0, c.duration)
				end
				c.pandemict:SetSize(o.bars.pandemic,o.bars.h)
				c.pandemict:SetTexture("Interface\\CastingBar\\UI-CastingBar-Spark")
				c.pandemict:SetVertexColor(1, 1, 1, 0.75);
				c.icon.file:SetTexture(c.iconfile)
				c.icon:SetSize(o.bars.h,o.bars.h)
				c.icon.file:SetTexCoord(0.1,0.9,0.1,0.9)
				c.icon:SetPoint("LEFT",-o.bars.h,0)
				c.t1:SetPoint("CENTER",o.bars.text_position*(o.bars.w/100),0);
				c.t1:SetFont(font,o.large_text_size,"OUTLINE")
				c.t2:SetPoint("RIGHT",-3,0);
				c.t2:SetFont(font,o.large_text_size,"OUTLINE")
				c.bg:SetVertexColor(colors[8][1],colors[8][2],colors[8][3],1)
				if not o.hide_text then c.t1:Show();c.t2:Show() end
				if not o.hide_icons then c.icon:Show(); end
				c.statusbar:Show()
				if(o.bars.pandemic > 0 and (c.t == "dot" or o.bars.proportional)) then c.pandemict:Show() end
			end
		end
		
		if c.t == "coe" or c.t == "hp" then
			local w
			if		o.layout == "horizontal" then
				w = o.boxes_h.w
			elseif	o.layout == "vertical" then
				w = o.boxes_v.w/2
			elseif	o.layout == "bars" then
				w = 40
			end
			c.frame:SetSize(w,20)
			c.frame:SetPoint("TOPLEFT", 0, 22)
			c.frame.t1:SetPoint("CENTER", 0, 0);c.t1:SetFont(font,o.small_text_size,"OUTLINE");c.t1:Show()
			if c.t == "coe" and o.hp then c.frame:SetPoint("TOPLEFT", w, 22) end
		end
	end

	if o.burst.enable then
		b:ClearAllPoints()
		b:Show()
		b:SetSize(o.burst.w, o.burst.h)
		if o.burst.x then
			b:SetPoint(o.burst.p, nil, o.burst.rp, o.burst.x, o.burst.y)
		else
			b:SetPoint("CENTER", 0, 0)
		end
		b.bg:SetAllPoints(true)
		b.text:SetPoint("CENTER",0,0)
		b.text:SetFont(font,o.large_text_size,"OUTLINE")
		b.text:SetTextColor(o.text_color[1],o.text_color[2],o.text_color[3])
		if o.burst.text then b.text:Show() else b.text:Hide() end
		tinsert(track, {t="burst",update=Update.burst})
	else
		b:Hide()
	end
end

local function Tidy()
	local TidyPlates = TidyPlates
	local time_left, icon, spell, pandemic, GUID, c
	for plate in pairs(TidyPlates.NameplatesByVisible) do
		if not plate.extended.widgets.DebuffWidget then return false end
		GUID = plate.extended.unit.guid
		if GUID then
			for id,frame in pairs(plate.extended.widgets.DebuffWidget.AuraIconFrames) do
				time_left = tonumber(frame.TimeLeft:GetText())
				icon = frame.Icon:GetTexture()
				if 		icon == "Interface\\Icons\\Spell_Shadow_AbominationExplosion" 	then spell =  	172; pandemic =  9
				elseif 	icon == "Interface\\Icons\\Spell_Shadow_CurseOfSargeras" 		then spell =  	980; pandemic = 12
				elseif	icon == "Interface\\Icons\\Spell_Shadow_UnstableAffliction_3" 	then spell =  30108; pandemic =  7
				elseif	icon == "Interface\\Icons\\Spell_Shadow_AuraOfDarkness"			then spell = 	603; pandemic = 30
				elseif	icon == "Interface\\Icons\\Ability_Mage_WorldInFlames"			then spell = 108686; pandemic =7.5
				elseif	icon == "Interface\\Icons\\Spell_Fire_Immolation"				then spell = 	348; pandemic =7.5
				else	spell = nil
				end
				if not frame.AffDots then
					frame.Icon:SetDrawLayer("ARTWORK")
					frame.Border:SetDrawLayer("BACKGROUND")
					frame.Border:SetSize(o.tidyplates.w,o.tidyplates.h)
					frame.Border:SetPoint("CENTER", 0, 0)
					frame.AffDots = true
				end
				if spell and time_left then
					c = FindColor(GUID,time_left,spell,pandemic)
					frame.Border:SetTexture(colors[c][1],colors[c][2],colors[c][3],o.tidyplates.transparency)
				else
					frame.Border:SetTexture(0,0,0,o.tidyplates.transparency)
				end
			end
		end
	end
end

local function onUpdate(self,elapsed)
    timer = timer + elapsed;
    if timer >= throttle then
		for k,v in pairs(track) do
			track[k].update(track[k])
		end
		if o.tidyplates.enable and TidyPlates then Tidy() end
        timer = 0
    end
end

local options_table = {
	type = "group",name = "AffDots (drag here to move options frame)",
	args = {
		lock = {
			order = 1,name = "Lock frames",type = "toggle",
			set = function(info,val) o.locked = not o.locked; Visibility(); end,
			get = function() return o.locked end
		},
		reset = {
			order = 1,name = "Reset options",type = "execute",
			func = function()
				AffDotsOptions110 = tablecopy(defaults)
				o = AffDotsOptions110;
				colors = {o.color1,o.color2,o.color3,o.color4,o.color5,o.color6,o.color7,o.color8,o.color9,o.color10}
				AffDots:GetLayoutOptions()
				InitFrames()
			end,
		},
		general={
			order = 1,name = "General",type = "group",
			args={
				affliction = {
					order = 1,name = "Affliction",type = "toggle",
					set = function(info,val) o.affliction = not o.affliction;InitFrames() end,
					get = function() return o.affliction end
				},
				demonology = {
					order = 2,name = "Demonology",type = "toggle",
					set = function(info,val) o.demonology = not o.demonology;InitFrames() end,
					get = function() return o.demonology end
				},
				destruction = {
					order = 2,name = "Destruction",type = "toggle",
					set = function(info,val) o.destruction = not o.destruction;InitFrames() end,
					get = function() return o.destruction end
				},
				hide = {
					order = 3,name = "Hide when not in combat",type = "toggle", width = "full",
					set = function(info,val) o.hide = not o.hide;InitFrames();Visibility() end,
					get = function(info) return o.hide end
				},
				hide_icons = {
					order = 5,name = "Hide icons",type = "toggle",
					set = function(info,val) o.hide_icons = not o.hide_icons;InitFrames() end,
					get = function(info) return o.hide_icons end
				},
				hide_text = {
					order = 6,name = "Hide text",type = "toggle",
					set = function(info,val) o.hide_text = not o.hide_text;InitFrames() end,
					get = function(info) return o.hide_text end
				},
				focus = {
					order = 7,name = "Enable focus",type = "toggle",
					set = function(info,val) o.focus = not o.focus;InitFrames();Visibility() end,
					get = function(info) return o.focus end
				},
				coe = {
					order = 8,name = "Enable CoE",type = "toggle",
					set = function(info,val) o.coe = not o.coe;InitFrames() end,
					get = function(info) return o.coe end
				},
				hp = {
					order = 9,name = "Enable HP%",type = "toggle",width = "full",
					set = function(info,val) o.hp = not o.hp;InitFrames() end,
					get = function(info) return o.hp end
				},
				target_size = {
					order = 10,name = "Target frame size",type = "range",
					min = 0.3,max = 3,step = 0.1,softMin = 0.3,softMax=3,
					set = function(info,val) o.scale = val;InitFrames() end,
					get = function(info) return o.scale end
				},
				focus_size = {
					order = 11,name = "Focus frame size",type = "range",
					min = 0.3,max = 3,step = 0.1,softMin = 0.3,softMax=3,
					set = function(info,val) o.focus_scale = val;InitFrames() end,
					get = function(info) return o.focus_scale end
				},
				large_text = {
					order = 12,name = "Text size",type = "range",
					min = 10,max = 30,step = 1,softMin = 10,softMax=30,
					set = function(info,val) o.large_text_size = val;InitFrames() end,
					get = function(info) return o.large_text_size end
				},
				small_text = {
					order = 13,name = "CoE/Hp text size",type = "range",
					min = 10,max = 30,step = 1,softMin = 10,softMax=30,
					set = function(info,val) o.small_text_size = val;InitFrames() end,
					get = function(info) return o.small_text_size end
				},
				font = {
					order = 14,name = 'Font',type = 'select',
					dialogControl = 'LSM30_Font',
					values = SharedMedia:HashTable("font"),
					set = function(self,key) o.font = key;InitFrames() end,
					get = function() return o.font end,
				},
				layout = {
					order = 15,name = "Layout",type = "select",
					values = {horizontal = "Horizontal", vertical = "Vertical", bars = "Bars"},
					set = function(info,val) o.layout = val;InitFrames();Visibility();AffDots:GetLayoutOptions() end,
					get = function(info) return o.layout end
				},
				color_text = {
					order = 16,name = "Change color of text",type = "toggle",
					set = function(info,val) o.color_text = not o.color_text;InitFrames() end,
					get = function(info) return o.color_text end
				},
				text_type = {
					order = 17,name = "Relative values",type = "toggle",
					set = function(info,val) o.reltext = not o.reltext end,
					get = function(info) return o.reltext end
				},
			}
		},
		affliction={
			order = 2,name = "Affliction",type = "group",
			args={
				show_haunt = {
					order = 1,name = "Show Haunt",type = "toggle",width = "full",
					set = function(info,val) o.aff.show_haunt = not o.aff.show_haunt;InitFrames() end,
					get = function(info) return o.aff.show_haunt end
				},
				desc = {
					order = 3,name = "Order:",type = "description",fontSize="medium"
				},
				agony = {
					order = 4,name = "Agony",type = "range",
					min = 1,max = 4,step = 1,softMin = 1,softMax=4,
					set = function(info,val) o.aff.agony = val - 1;InitFrames() end,
					get = function(info) return o.aff.agony + 1 end
				},
				corr = {
					order = 5,name = "Corruption",type = "range",
					min = 1,max = 4,step = 1,softMin = 1,softMax=4,
					set = function(info,val) o.aff.corr = val - 1;InitFrames() end,
					get = function(info) return o.aff.corr + 1 end
				},
				ua = {
					order = 6,name = "UA",type = "range",
					min = 1,max = 4,step = 1,softMin = 1,softMax=4,
					set = function(info,val) o.aff.ua = val - 1;InitFrames() end,
					get = function(info) return o.aff.ua + 1 end
				},
				haunt = {
					order = 7,name = "Haunt",type = "range",
					min = 1,max = 4,step = 1,softMin = 1,softMax=4,
					set = function(info,val) o.aff.haunt = val - 1;InitFrames() end,
					get = function(info) return o.aff.haunt + 1 end
				},
			}
		},
		demonology={
			order = 3,name = "Demonology",type = "group",
			args={
				hog = {
					order = 1,name = "Show Hand of Guldan",type = "toggle",width = "full",
					set = function(info,val) o.demo.show_hog = not o.demo.show_hog;InitFrames() end,
					get = function(info) return o.demo.show_hog end
				},
				df = {
					order = 2,name = "Show Demonic Fury",type = "toggle",width = "full",
					set = function(info,val) o.demo.show_df = not o.demo.show_df;InitFrames() end,
					get = function(info) return o.demo.show_df end
				},
				desc = {
					order = 3,name = "Order:",type = "description",fontSize="medium"
				},
				corr = {
					order = 4,name = "Corruption",type = "range",
					min = 1,max = 4,step = 1,softMin = 1,softMax=4,
					set = function(info,val) o.demo.corr = val - 1;InitFrames() end,
					get = function(info) return o.demo.corr + 1 end
				},
				doom = {
					order = 5,name = "Doom",type = "range",
					min = 1,max = 4,step = 1,softMin = 1,softMax=4,
					set = function(info,val) o.demo.doom = val - 1;InitFrames() end,
					get = function(info) return o.demo.doom + 1 end
				},
				show_hog = {
					order = 6,name = "Hand of Guldan",type = "range",
					min = 1,max = 4,step = 1,softMin = 1,softMax=4,
					set = function(info,val) o.demo.hog = val - 1;InitFrames() end,
					get = function(info) return o.demo.hog + 1 end
				},
				show_df = {
					order = 7,name = "Demonic Fury",type = "range",
					min = 1,max = 4,step = 1,softMin = 1,softMax=4,
					set = function(info,val) o.demo.df = val - 1;InitFrames() end,
					get = function(info) return o.demo.df + 1 end
				},
				switch1 = {
					order = 8,name = "Demonic Fury <=",type = "range",
					min = 1,max = 1000,step = 1,softMin = 1,softMax=1000,
					set = function(info,val) o.demo.switch1=val end,
					get = function(info) return o.demo.switch1 end
				},
				color1 = {
					order = 9,name = "",type = "color",
					set = function(info,r,g,b) o.demo.color1={r,g,b} end,
					get = function(info) return o.demo.color1[1],o.demo.color1[2],o.demo.color1[3],1 end
				},
				switch2 = {
					order = 10,name = "Demonic Fury <=",type = "range",
					min = 1,max = 1000,step = 1,softMin = 1,softMax=1000,
					set = function(info,val) o.demo.switch2=val end,
					get = function(info) return o.demo.switch2 end
				},
				color2 = {
					order = 11,name = "",type = "color",
					set = function(info,r,g,b) o.demo.color2={r,g,b} end,
					get = function(info) return o.demo.color2[1],o.demo.color2[2],o.demo.color2[3],1 end
				},
				switch3 = {
					order = 12,name = "Demonic Fury <=",type = "range",
					min = 1,max = 1000,step = 1,softMin = 1,softMax=1000,
					set = function(info,val) o.demo.switch3=val end,
					get = function(info) return o.demo.switch3 end
				},
				color3 = {
					order = 13,name = "",type = "color",
					set = function(info,r,g,b) o.demo.color3={r,g,b} end,
					get = function(info) return o.demo.color3[1],o.demo.color3[2],o.demo.color3[3],1 end
				},
				switch4 = {
					order = 14,name = "Demonic Fury <=",type = "range",
					min = 1,max = 1000,step = 1,softMin = 1,softMax=1000,
					set = function(info,val) o.demo.switch4=val end,
					get = function(info) return o.demo.switch4 end
				},
				color4 = {
					order = 15,name = "",type = "color",
					set = function(info,r,g,b) o.demo.color4={r,g,b} end,
					get = function(info) return o.demo.color4[1],o.demo.color4[2],o.demo.color4[3],1 end
				},
				switch5 = {
					order = 16,name = "Demonic Fury <=",type = "range",
					min = 1,max = 1000,step = 1,softMin = 1,softMax=1000,
					set = function(info,val) o.demo.switch5=val end,
					get = function(info) return o.demo.switch5 end
				},
				color5 = {
					order = 17,name = "",type = "color",
					set = function(info,r,g,b) o.demo.color5={r,g,b} end,
					get = function(info) return o.demo.color5[1],o.demo.color5[2],o.demo.color5[3],1 end
				},
			}
		},
		destruction={
			order = 3,name = "Destruction",type = "group",
			args={
				show_conflag = {
					order = 1,name = "Show Conflagrate",type = "toggle",width = "full",
					set = function(info,val) o.destro.show_conflag = not o.destro.show_conflag;InitFrames() end,
					get = function(info) return o.destro.show_conflag end
				},
				show_rof = {
					order = 2,name = "Show Rain of Fire",type = "toggle",width = "full",
					set = function(info,val) o.destro.show_rof = not o.destro.show_rof;InitFrames() end,
					get = function(info) return o.destro.show_rof end
				},
				show_embers = {
					order = 3,name = "Show Burning Embers",type = "toggle",width = "full",
					set = function(info,val) o.destro.show_embers = not o.destro.show_embers;InitFrames() end,
					get = function(info) return o.destro.show_embers end
				},
				desc1 = {
					order = 4,name = "Order:",type = "description",fontSize="medium"
				},
				immo = {
					order = 5,name = "Immolate",type = "range",
					min = 1,max = 4,step = 1,softMin = 1,softMax=4,
					set = function(info,val) o.destro.immo = val - 1;InitFrames() end,
					get = function(info) return o.destro.immo + 1 end
				},
				conflag = {
					order = 6,name = "Conflagrate",type = "range",
					min = 1,max = 4,step = 1,softMin = 1,softMax=4,
					set = function(info,val) o.destro.conflag = val - 1;InitFrames() end,
					get = function(info) return o.destro.conflag + 1 end
				},
				rof = {
					order = 7,name = "Rain of Fire",type = "range",
					min = 1,max = 4,step = 1,softMin = 1,softMax=4,
					set = function(info,val) o.destro.rof = val - 1;InitFrames() end,
					get = function(info) return o.destro.rof + 1 end
				},
				embers = {
					order = 8,name = "Burning Embers",type = "range",
					min = 1,max = 4,step = 1,softMin = 1,softMax=4,
					set = function(info,val) o.destro.embers = val - 1;InitFrames() end,
					get = function(info) return o.destro.embers + 1 end
				},
				desc2 = {
					order = 9,name = "Colors for Burning Embers:",type = "description",fontSize="medium",width="full",
				},
				switch1 = {
					order = 10,name = "Burning Embers <=",type = "range",
					min = 1,max = 40,step = 1,softMin = 1,softMax=40,
					set = function(info,val) o.destro.switch1=val end,
					get = function(info) return o.destro.switch1 end
				},
				color1 = {
					order = 11,name = "",type = "color",
					set = function(info,r,g,b) o.destro.color1={r,g,b} end,
					get = function(info) return o.destro.color1[1],o.destro.color1[2],o.destro.color1[3],1 end
				},
				switch2 = {
					order = 12,name = "Burning Embers <=",type = "range",
					min = 1,max = 40,step = 1,softMin = 1,softMax=40,
					set = function(info,val) o.destro.switch2=val end,
					get = function(info) return o.destro.switch2 end
				},
				color2 = {
					order = 13,name = "",type = "color",
					set = function(info,r,g,b) o.destro.color2={r,g,b} end,
					get = function(info) return o.destro.color2[1],o.destro.color2[2],o.destro.color2[3],1 end
				},
				switch3 = {
					order = 14,name = "Burning Embers <=",type = "range",
					min = 1,max = 40,step = 1,softMin = 1,softMax=40,
					set = function(info,val) o.destro.switch3=val end,
					get = function(info) return o.destro.switch3 end
				},
				color3 = {
					order = 15,name = "",type = "color",
					set = function(info,r,g,b) o.destro.color3={r,g,b} end,
					get = function(info) return o.destro.color3[1],o.destro.color3[2],o.destro.color3[3],1 end
				},
				switch4 = {
					order = 16,name = "Burning Embers <=",type = "range",
					min = 1,max = 40,step = 1,softMin = 1,softMax=40,
					set = function(info,val) o.destro.switch4=val end,
					get = function(info) return o.destro.switch4 end
				},
				color4 = {
					order = 17,name = "",type = "color",
					set = function(info,r,g,b) o.destro.color4={r,g,b} end,
					get = function(info) return o.destro.color4[1],o.destro.color4[2],o.destro.color4[3],1 end
				},
			}
		},
		colors={
			order = 5,name = "Colors",type = "group",
			args={
				color1 = {
					order = 1,width = "full",name = "Current stats are better, Pandemic safe",type = "color",
					set = function(info,r,g,b) colors[1]={r,g,b}; o.color1={r,g,b} end,
					get = function(info) return colors[1][1],colors[1][2],colors[1][3],1 end
				},
				color2 = {
					order = 2,width = "full",name = "Current stats are the same, Pandemic safe",type = "color",
					set = function(info,r,g,b) colors[2]={r,g,b}; o.color2={r,g,b} end,
					get = function(info) return colors[2][1],colors[2][2],colors[2][3],1 end
				},
				color3 = {
					order = 3,width = "full",name = "Current stats are worse, Pandemic safe",type = "color",
					set = function(info,r,g,b) colors[3]={r,g,b}; o.color3={r,g,b} end,
					get = function(info) return colors[3][1],colors[3][2],colors[3][3],1 end
				},
				color4 = {
					order = 4,width = "full",name = "Current stats are better, not Pandemic safe",type = "color",
					set = function(info,r,g,b) colors[4]={r,g,b}; o.color4={r,g,b} end,
					get = function(info) return colors[4][1],colors[4][2],colors[4][3],1 end
				},
				color5 = {
					order = 5,width = "full",name = "Current stats are the same, not Pandemic safe",type = "color",
					set = function(info,r,g,b) colors[5]={r,g,b}; o.color5={r,g,b} end,
					get = function(info) return colors[5][1],colors[5][2],colors[5][3],1 end
				},
				color6 = {
					order = 6,width = "full",name = "Current stats are worse, not Pandemic safe",type = "color",
					set = function(info,r,g,b) colors[6]={r,g,b}; o.color6={r,g,b} end,
					get = function(info) return colors[6][1],colors[6][2],colors[6][3],1 end
				},
				color7 = {
					order = 7,width = "full",name = "No dot on target",type = "color",
					set = function(info,r,g,b) colors[7]={r,g,b}; o.color7={r,g,b};InitFrames() end,
					get = function(info) return colors[7][1],colors[7][2],colors[7][3],1 end
				},
				color9 = {
					order = 8,width = "full",name = "CoE/Hp/Haunt color",type = "color",
					set = function(info,r,g,b) colors[9]={r,g,b}; o.color9={r,g,b};InitFrames() end,
					get = function(info) return colors[9][1],colors[9][2],colors[9][3],1 end
				},
				text_color = {
					order = 9,width = "full",name = "Text color",type = "color",
					set = function(info,r,g,b) o.text_color={r,g,b};InitFrames() end,
					get = function(info) return o.text_color[1],o.text_color[2],o.text_color[3],1 end
				},
				color_switch = {
					order = 10,name = "Color switch",type = "range",
					desc = "When refresh is not pandemic safe,\nswitch color only if current stats are at least x% better",
					min = 0,max = 40,step = 1,softMin = 0,softMax=40,
					set = function(info,val) o.color_switch = 1+val/100 end,
					get = function(info) return (o.color_switch-1)*100 end
				},
				transparency = {
					order = 11,name = "Transparency",type = "range",
					min = 0,max = 1,step = 0.1,softMin = 0,softMax=1,
					set = function(info,val) o.transparency = val;InitFrames() end,
					get = function(info) return o.transparency end
				},
			}
		},
		layout={
			order = 6,name = "Layout",type = "group",
			args={}
		},
		tidy_plates={
			order = 7,name = "TidyPlates",type = "group",
			args={
				enable = {
					order = 1,name = "Integrate dot colors in TidyPlates",type = "toggle",width = "full",
					set = function(info,val) o.tidyplates.enable = not o.tidyplates.enable end,
					get = function(info) return o.tidyplates.enable end
				},
				width = {
					order = 2,name = "Width",type = "range",width = "full",
					min = 10,max = 30,step = 1,softMin = 10,softMax=30,
					set = function(info,val) o.tidyplates.w = val end,
					get = function(info) return o.tidyplates.w end
				},
				heigth = {
					order = 5,name = "Heigth",type = "range",width = "full",
					min = 10,max = 30,step = 1,softMin = 10,softMax=30,
					set = function(info,val) o.tidyplates.h = val end,
					get = function(info) return o.tidyplates.h end
				},
				transparency = {
					order = 7,name = "Transparency",type = "range",width = "full",
					min = 0,max = 100,step = 10,softMin = 0,softMax=100,
					set = function(info,val) o.tidyplates.transparency = val/100 end,
					get = function(info) return o.tidyplates.transparency*100 end
				},
				desc = {
					order = 8,name = "If you want dots to show in certain order in TidyPlates, go to 'Tidy Plates Hub: Tank' and 'Tidy Plates Hub: Damage', find 'Buffs & Debuffs' section, set 'Filter Mode' to 'Specific Auras' and write this in Aura List:\nMy 980\nMy 172\nMy 87389\nMy 30108\nAll 1490\nFirst line is Agony, second and third Corruption, fourth UA, fifth CoE. Reorder them as needed. Put other auras in list if you need them",type = "description",fontSize="medium"
				},
			}
		},
		burst={
			order = 8, name = "Burst", type = "group",
			args={
				desc = {
					order = 1,name = "Compares your current damage to your baseline damage, changes color if increase is at least x% higher.\nIntended to show when you have enough damage increase effects and it is a good time to spend your resources. Set it as high as you possibly can for maximum effect.\nTo save your baseline damage, click 'Set current as baseline' button, make sure you are fully buffed (Dark Intent when solo, party buffed when in 5-man, fully buffed with food and flask in raid) and without active procs or potions. You need to click it once for each spec, when you change gear or some buffs become available or unavailable.\n\nAffliction is special and needs active dots present on target to switch colors, demonology and destruction does not have this requirement.",type = "description",fontSize="medium"
				},
				enable = {
					order = 2,name = "Enable",type = "toggle",width = "full",
					set = function(info,val) o.burst.enable = not o.burst.enable; InitFrames() end,
					get = function(info) return o.burst.enable end
				},
				current = {
					order = 3,name = "Set current as baseline",type = "execute",width = "full",
					func = function()
						AffDots:BurstDefaults()
					end,
				},
				switch = {
					order = 4,name = "Damage increase needed to change color (percent)",type = "range",width = "full",
					min = 10,max = 100,step = 1,softMin = 10,softMax=100,
					set = function(info,val) o.burst.switch = 1+val/100;InitFrames() end,
					get = function(info) return (o.burst.switch-1)*100 end
				},
				color = {
					order = 5,name = "Color",type = "color",
					set = function(info,r,g,b) o.burst.color={r,g,b}; InitFrames() end,
					get = function(info) return o.burst.color[1],o.burst.color[2],o.burst.color[3],1 end
				},
				text = {
					order = 6,name = "Show text",type = "toggle",
					set = function(info,val) o.burst.text = not o.burst.text;InitFrames() end,
					get = function(info) return o.burst.text end
				},
				height = {
					order = 7,name = "Height",type = "range",
					min = 10,max = 100,step = 1,softMin = 10,softMax=100,
					set = function(info,val) o.burst.h = val;InitFrames() end,
					get = function(info) return o.burst.h end
				},
				width = {
					order = 8,name = "Width",type = "range",
					min = 10,max = 200,step = 1,softMin = 10,softMax=200,
					set = function(info,val) o.burst.w = val;InitFrames() end,
					get = function(info) return o.burst.w end
				},
				desc2 = {
					order = 9,name = "\nTo quickly set baseline values, press the following key combination on Burst frame:",type = "description",fontSize="medium"
				},
				key = {
					order = 10,name = "Key",type = "select",
					values = {LSHIFT="Left SHIFT",RSHIFT = "Right SHIFT",LCTRL = "Left CTRL",RCTRL = "Right CTRL",LALT = "Left ALT",RALT = "Right ALT"},
					set = function(info, val) o.burst.key = val end,
					get = function(info) return o.burst.key end
				},
				mousekey = {
					order = 11,name = "Mouse button",type = "select",
					values = {RightButton = "Right mouse button"},
					set = function(info, val) o.burst.mousekey = val end,
					get = function(info) return o.burst.mousekey end
				},
				desc3 = {
					order = 12,name = "Burst frame for other classes: www.curse.com/addons/wow/mesmash",type = "description",fontSize="medium"
				},
			}
		}
	}
}

function AffDots:GetLayoutOptions()
	if o.layout == "horizontal" then
		options_table.args.layout.args = {
				icon_size = {
					order = 3,name = "Icon size",type = "range",
					min = 10,max = 60,step = 1,softMin = 10,softMax=60,
					set = function(info,val) o.boxes_h.icon_size = val;InitFrames() end,
					get = function(info) return o.boxes_h.icon_size end
				},
				icon_position = {
					order = 4,name = "Icon position",type = "range",
					min = 0,max = 60,step = 1,softMin = 0,softMax=60,
					set = function(info,val) o.boxes_h.icon_position = val;InitFrames() end,
					get = function(info) return o.boxes_h.icon_position end
				},
				x_size = {
					order = 5,name = "Height",type = "range",
					min = 20,max = 100,step = 1,softMin = 20,softMax=100,
					set = function(info,val) o.boxes_h.h = val;InitFrames() end,
					get = function(info) return o.boxes_h.h end
				},
				y_size = {
					order = 6,name = "Width",type = "range",
					min = 20,max = 100,step = 1,softMin = 20,softMax=100,
					set = function(info,val) o.boxes_h.w = val;InitFrames() end,
					get = function(info) return o.boxes_h.w end
				},
				text_position = {
					order = 7,name = "Text position",type = "range",
					min = 0,max = 100,step = 1,softMin = 0,softMax=100,
					set = function(info,val) o.boxes_h.text_position = val;InitFrames() end,
					get = function(info) return o.boxes_h.text_position end
				},
			}
	elseif o.layout == "vertical" then
		options_table.args.layout.args = {
				icon_size = {
					order = 3,name = "Icon size",type = "range",
					min = 10,max = 60,step = 1,softMin = 10,softMax=60,
					set = function(info,val) o.boxes_v.icon_size = val;InitFrames() end,
					get = function(info) return o.boxes_v.icon_size end
				},
				icon_position = {
					order = 4,name = "Icon position",type = "range",
					min = 0,max = 60,step = 1,softMin = 0,softMax=60,
					set = function(info,val) o.boxes_v.icon_position = val;InitFrames() end,
					get = function(info) return o.boxes_v.icon_position end
				},
				text_position = {
					order = 6,name = "Text position",type = "range",
					min = 0,max = 100,step = 1,softMin = 0,softMax=100,
					set = function(info,val) o.boxes_v.text_position = val;InitFrames() end,
					get = function(info) return o.boxes_v.text_position end
				},
				x_size = {
					order = 7,name = "Horizontal size",type = "range",
					min = 20,max = 100,step = 1,softMin = 20,softMax=100,
					set = function(info,val) o.boxes_v.h = val;InitFrames() end,
					get = function(info) return o.boxes_v.h end
				},
				y_size = {
					order = 8,name = "Vertical size",type = "range",
					min = 20,max = 100,step = 1,softMin = 20,softMax=100,
					set = function(info,val) o.boxes_v.w = val;InitFrames() end,
					get = function(info) return o.boxes_v.w end
				},
			}
	elseif o.layout == "bars" then
		options_table.args.layout.args = {
				pandemic_width = {
					order = 2,name = "Pandemic indicator width",type = "range",
					min = 0,max = 5,step = 1,softMin = 0,softMax=5,
					set = function(info,val) o.bars.pandemic = val;InitFrames() end,
					get = function(info) return o.bars.pandemic end
				},
				text_position = {
					order = 5,name = "Text position",type = "range",
					min = -50,max = 50,step = 1,softMin = -50,softMax=50,
					set = function(info,val) o.bars.text_position = val;InitFrames() end,
					get = function(info) return o.bars.text_position end
				},
				bar_height = {
					order = 7,name = "Bar height",type = "range",
					min = 10,max = 100,step = 1,softMin = 10,softMax=100,
					set = function(info,val) o.bars.h = val;InitFrames() end,
					get = function(info) return o.bars.h end
				},
				bar_width = {
					order = 8,name = "Bar width",type = "range",
					min = 100,max = 500,step = 1,softMin = 100,softMax=500,
					set = function(info,val) o.bars.w = val;InitFrames() end,
					get = function(info) return o.bars.w end
				},
				margin = {
					order = 9,name = "Spacing",type = "range",
					min = 0,max = 10,step = 1,softMin = 0,softMax=10,
					set = function(info,val) o.bars.margin = val;InitFrames() end,
					get = function(info) return o.bars.margin end
				},
				bg = {
					order = 10,type = 'select',name = 'Background',
					dialogControl = 'LSM30_Statusbar',
					values = SharedMedia:HashTable("statusbar"),
					set = function(self,key) o.bg = key;InitFrames() end,
					get = function() return o.bg end,
				},
				color8 = {
					order = 11,width = "full",name = "Bar background color",type = "color",
					set = function(info,r,g,b) colors[8]={r,g,b}; o.color8={r,g,b};InitFrames() end,
					get = function(info) return colors[8][1],colors[8][2],colors[8][3],1 end
				},
				proportional = {
					order = 13,name = "Enable proportional bars",type = "toggle",width = "full",
					desc = "All bars will move at the same speed",
					set = function(info,val) o.bars.proportional = not o.bars.proportional;InitFrames() end,
					get = function(info) return o.bars.proportional end
				},
				proportional_limit = {
					order = 14,name = "Proportional bars time limit",type = "range",
					desc = "Maximum numbers of seconds to display in proportional bar",
					min = 20,max = 40,step = 1,softMin = 20,softMax=40,
					set = function(info,val) o.bars.limit = val;InitFrames() end,
					get = function(info) return o.bars.limit end
				},
			}
	else
		options_table.args.layout.args = {}
	end
end


SLASH_AFFDOTS1 = '/affdots'
function AffDotsHandler(msg, editBox)
	LibStub("AceConfigDialog-3.0"):Open("AffDots")
end
SlashCmdList["AFFDOTS"] = AffDotsHandler

local function VariablesLoaded()
	AffDotsOptions110 = AffDotsOptions110 or tablecopy(defaults)
	o = AffDotsOptions110
	if(not o.version_num or o.version_num < 12004) then
		AffDotsOptions110 = tablecopy(defaults); o = AffDotsOptions110;
	end
	colors = {o.color1,o.color2,o.color3,o.color4,o.color5,o.color6,o.color7,o.color8,o.color9,o.color10}
	AffDots:GetLayoutOptions()
end

function AffDots:MODIFIER_STATE_CHANGED(event,key,state)
	if key == o.burst.key and state == 1 then
		b:EnableMouse(true)
		setburst = true
	else
		b:EnableMouse(not o.locked)
		setburst = false
	end
end

function AffDots:PLAYER_REGEN_ENABLED()
	in_combat = false; Visibility()
	local t = GetTime()
	for k,v in pairs(targets) do
		if targets[k][2] < t-100 then targets[k]=nil end
	end
end

function AffDots:PLAYER_REGEN_DISABLED()
	in_combat = true; Visibility()
end

function AffDots:PLAYER_FOCUS_CHANGED()
	Visibility()
end

function AffDots:PLAYER_TALENT_UPDATE()
	spec 	= GetSpecialization()
	GetDotDmg()
	InitFrames()
	Visibility()
end

function AffDots:OnInitialize()
	LibStub("AceConfig-3.0"):RegisterOptionsTable("AffDots", options_table)
	AffDots:GetLayoutOptions()
end
function AffDots:OnEnable()
	if select(2, UnitClass("player")) ~= "WARLOCK" then m:Hide(); f:Hide(); b:Hide(); return end
	me		= UnitGUID("player")
	spec	= GetSpecialization()
	VariablesLoaded()
	GetDotDmg()
	InitFrames()
	Visibility()
	self:RegisterEvent("PLAYER_TALENT_UPDATE")
	self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED", CombatLog)
	self:RegisterEvent("PLAYER_REGEN_ENABLED")
	self:RegisterEvent("PLAYER_REGEN_DISABLED")
	self:RegisterEvent("COMBAT_RATING_UPDATE", GetDotDmg)
	self:RegisterEvent("SPELL_POWER_CHANGED", GetDotDmg)
	self:RegisterEvent("UNIT_STATS", GetDotDmg)
	self:RegisterEvent("PLAYER_DAMAGE_DONE_MODS", GetDotDmg)
	self:RegisterEvent("PLAYER_FOCUS_CHANGED")
	self:RegisterEvent("MODIFIER_STATE_CHANGED")
	m:SetScript("OnUpdate", onUpdate)
end
function AffDots:OnDisable()
	
end

AffDots.targets, AffDots.dot_damage = targets, dot_damage